/*
   This is a modern version of makeAdder that uses
   (nested) lambda expressions and functional interfaces.
*/
import java.util.function.Function;

public class MakeAdder_v1
{
   public static void main(String args[])
   {
      Function<Integer, Function<Integer,Integer>> makeAdder = x -> (y -> x + y);

      Function<Integer,Integer> add4 = makeAdder.apply(4);

      System.out.println( add4.apply(5) );
   }
}

/*
Use this URL to run this program in the Java Visualizer.

https://cscircles.cemc.uwaterloo.ca/java_visualize/#code=import+java.util.function.Function%3B%0A%0Apublic+class+MakeAdder_v1%0A%7B%0A+++public+static+void+main(String+args%5B%5D)%0A+++%7B%0A++++++Function%3CInteger,+Function%3CInteger,Integer%3E%3E+%0A+++++++++makeAdder+%3D+x+-%3E+%0A++++++++++++++++++++++++++(y+-%3E+%0A++++++++++++++++++++++++++++++++x+%2B+y)%3B%0A%0A++++++Function%3CInteger,Integer%3E+add4+%3D+makeAdder.apply(4)%3B%0A%0A++++++System.out.println(+add4.apply(5)+)%3B%0A+++%7D%0A%7D&mode=edit
*/