/*
   Here is a classic OOP version of makeCounter along
   the lines of MakeAdder_v5.java. There is no nested
   function in this OO version (so there is no need
   for a closure). Instead, there is an instance method
   in an object and it references an instance variable.
*/
import java.util.function.IntSupplier;


public class MakeCounter_v2
{
   public static void main(String args[])
   {
      Counter countFrom4 = new Counter(4);

      System.out.println( countFrom4.getAsInt() );
      System.out.println( countFrom4.getAsInt() );
      System.out.println( countFrom4.getAsInt() );
   }
}


class Counter implements IntSupplier
{
   int x;
   public Counter(int x){this.x = x;}
   public int getAsInt(){return ++x;}
}
